
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert             = "Price Cross Ma Ea_v1.05";
extern string _gen                    = "General Settings";
extern bool   EcnBroker               = true;
extern bool   UseAutoMagic            = true;
extern int    ManualMagic             = 46464665;  
extern double lStopLoss               = 100;
extern double sStopLoss               = 100;
extern double lTakeProfit             = 300;
extern double sTakeProfit             = 300;
extern double lTrailingStop           = 50;
extern double sTrailingStop           = 50;
extern double BreakEven               = 25;
extern int    LockInPips              = 25;        // Profit Lock in pips
extern bool   TrailAfterBreakEvenOnly = true;
extern int    Slippage                = 4;
extern double Lots                    = 0.1;
extern double MaximumRisk             = 0;
extern double DecreaseFactor          = 3;

extern string XX                      = "Indicators";  
extern string _ma                     = "Ma Settings";
extern int    timeFrame               = 0;     
extern int    maPeriod                = 21;
extern int    maShift                 = 0;
extern int    maMode                  = MODE_EMA;
extern int    maPrice                 = PRICE_CLOSE;
extern int    maBar                   = 1;  

extern string MinDistance_Setting     = "Min Cross Distance Setting";
extern int    MinCrossDistance        = 0;    //Always positive, 0:disable
extern int    MinDistanceBarsBack     = 0;    //Number of bar to keep checking for the entry condition  

extern string MaxDistance_Setting     = "Max Cross Distance Setting";
extern int    MaxCrossDistance        = 0;    //Always positive, 0:disable
extern int    MaxDistanceBarsBack     = 0;    //Number of bar to keep checking for the entry condition  

extern string x                       = "Order Close Settings";
extern bool   CloseOnTrendChange      = false;
extern string _x                      = "Indicator settings used for Close on trend change";
extern int    cl.timeFrame            = 0;     
extern int    cl.maPeriod             = 21;
extern int    cl.maShift              = 0;
extern int    cl.maMode               = MODE_EMA;
extern int    cl.maPrice              = PRICE_CLOSE;
extern int    clBar                   = 1;  

extern string tf                      = "Time Filter";
extern bool   UseHourTrade            = true;
extern int    StartHour               = 3;
extern int    StartMinute             = 0;
extern int    EndHour                 = 22;
extern int    EndMinute               = 0;

extern string __                      = "Setting for friday positions close";
extern bool   CloseOnFriday           = false;
extern int    FridayCloseHour         = 21; 
extern int    FridayCloseMinute       = 59; 

extern string os                      = "Other Stuff";
extern bool   ShowAlerts              = false;
extern color  clOpenBuy               = Blue;
extern color  clCloseBuy              = Aqua;
extern color  clOpenSell              = Red;
extern color  clCloseSell             = Violet;

//
//
//
//
//

double   pipMultiplier = 1;
double   pPoint;

string   s_symbol;

int      MAGIC;
int      digit;

datetime CrossTime;

//
//
//
//
//

int init() 
{
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   //
   //
   //
   //
   //
   
   if (UseAutoMagic) MAGIC = GetMagic();
               else  MAGIC = ManualMagic;    
              
return(0);
}

//
//
//
//
//

int deinit() 
{ 
   Comment("");
   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{  
   if (BreakEven>0)        breakEvenManager();
   if (lTrailingStop > 0)  TrailingPositionsBuy();
   if (sTrailingStop > 0)  TrailingPositionsSell();
   if (CloseOnTrendChange) CheckForClose();
   
   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)  { OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   int openedOrders = 0;
   for (i=OrdersTotal()-1; i>=0; i--)
   { 
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()      != s_symbol) continue;
         if (OrderMagicNumber() != MAGIC)    continue;
           openedOrders++;
   }
   
   //
   //
   //
   //
   //
   
   if (openedOrders <= 0)
   {
     double clnow      = iClose(s_symbol,timeFrame,maBar);
     double clpre      = iClose(s_symbol,timeFrame,maBar+1);
     double manow      = iMA(s_symbol,timeFrame,maPeriod,maShift,maMode,maPrice,maBar);
     double mapre      = iMA(s_symbol,timeFrame,maPeriod,maShift,maMode,maPrice,maBar+1);
     int    shiftCROSS = iBarShift(s_symbol,timeFrame,CrossTime);
     double Distance   = MathFloor(MathAbs((clnow-manow)/pPoint));
     
     //
     //
     //
     //
     //
     
     if (clnow > manow && clpre < mapre)
     {
        CrossTime = iTime(NULL,timeFrame,0);
        if ((MinDistanceBarsBack >= 0 && MinCrossDistance >= 0) || (MaxDistanceBarsBack >= 0 && MaxCrossDistance >= 0)) 
        {
          if ((shiftCROSS<=MinDistanceBarsBack && Distance>=MinCrossDistance) || (shiftCROSS<=MaxDistanceBarsBack && Distance<=MaxCrossDistance))  
          {
            OpenBuy();
            return(0);
          }
        }
     }
     
     if (clnow < manow && clpre > mapre)
     {
        CrossTime = iTime(NULL,timeFrame,0);
        if ((MinDistanceBarsBack >= 0 && MinCrossDistance >= 0) || (MaxDistanceBarsBack >= 0 && MaxCrossDistance >= 0)) 
        {
          if ((shiftCROSS<=MinDistanceBarsBack && Distance>=MinCrossDistance) || (shiftCROSS<=MaxDistanceBarsBack && Distance<=MaxCrossDistance))  
          {
            OpenSell();
            return(0);
          }
        }
     }
  }
  
  //
  //
  //
  //
  //
  
  if (UseHourTrade)
  {
    if(!(TimeHour(TimeCurrent()) > StartHour || (TimeHour(TimeCurrent()) == StartHour && TimeMinute(TimeCurrent()) >= StartMinute &&
         TimeHour(TimeCurrent()) < EndHour   || (TimeHour(TimeCurrent()) == EndHour   && TimeMinute(TimeCurrent()) <= EndMinute)))) 
     {      Comment("Non-Trading Hours!");  return(0);  }
                       
   }
return (0);
}

//
//
//
//
//

void breakEvenManager() 
{
   double pAsk = Ask; 
   double pBid = Bid; 
   for(int i=OrdersTotal()-1; i>=0; i--)
  	{ 
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()     != s_symbol) continue;
      if(OrderMagicNumber()!= MAGIC)    continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_BUY)
      {
        if (pBid-OrderOpenPrice()>pPoint*BreakEven*pipMultiplier) 
        {
          double BuyStop = OrderOpenPrice()+LockInPips*pPoint*pipMultiplier;
          if (OrderStopLoss() < BuyStop) 
          OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(BuyStop,digit),NormalizeDouble(OrderTakeProfit(),digit),LightGreen);
		    return;
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_SELL)
      {
        if (OrderOpenPrice()-pAsk > pPoint*BreakEven*pipMultiplier) 
        {
           double SellStop = OrderOpenPrice()-LockInPips*pPoint*pipMultiplier;
           if (OrderStopLoss() > SellStop) 
           OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(SellStop,digit),NormalizeDouble(OrderTakeProfit(),digit),DarkOrange);
		     return;
        }
      }   
   }
}   

//
//
//
//
//

void TrailingPositionsBuy() { 
   double pBid = Bid; 
   for (int i = OrdersTotal()-1; i >=0 ; i--) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()<OrderOpenPrice()) return(0); }
                if (pBid - OrderOpenPrice()   > lTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() < pBid  - lTrailingStop * pPoint * pipMultiplier) 
                      ModifyStopLoss(   pBid  - lTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   double pAsk = Ask; 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()>OrderOpenPrice()) return(0); }
                if (OrderOpenPrice()  - pAsk > sTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() > pAsk + sTrailingStop * pPoint * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(   pAsk + sTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   double minStop = 0;
   double pBid    = Bid;
   double pAsk    = Ask;
   double sl      = MarketInfo(s_symbol,MODE_STOPLEVEL);   
   bool   canGo   = false;
      if (OrderType()==OP_BUY)
            { minStop = pBid-sl*pPoint; canGo = ldStopLoss<=minStop; }
      else  { minStop = pAsk+sl*pPoint; canGo = ldStopLoss>=minStop; }
      if (canGo)
      {
        fm = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(ldStopLoss,digit),NormalizeDouble(OrderTakeProfit(),digit),0,CLR_NONE); 
        if (fm == false)
        {
	        int    ErrorCode = GetLastError();
	        string ErrDesc   = ErrorDescription(ErrorCode);
	        string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
   	        if (ShowAlerts   == true) Alert(ErrAlert);
            	  string ErrLog = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
      	  Print(ErrLog);
      	}
      }      	
      else Print("Stop loss to close to current price");

}  

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)-lStopLoss  *pPoint*pipMultiplier,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)+lTakeProfit*pPoint*pipMultiplier,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)+sStopLoss  *pPoint*pipMultiplier,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)-sTakeProfit*pPoint*pipMultiplier,digit);
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double cl.clnow = iClose(s_symbol,cl.timeFrame,clBar);
   double cl.clpre = iClose(s_symbol,cl.timeFrame,clBar+1);
   double cl.manow = iMA(s_symbol,cl.timeFrame,cl.maPeriod,cl.maShift,cl.maMode,cl.maPrice,clBar);
   double cl.mapre = iMA(s_symbol,cl.timeFrame,cl.maPeriod,cl.maShift,cl.maMode,cl.maPrice,clBar+1);
     
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (cl.clnow < cl.manow && cl.clpre > cl.mapre)
        {
          bool buyClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,clCloseBuy);
          if (buyClose == false)
          {
            int ErrorCode   = GetLastError();
            string ErrDesc  = ErrorDescription(ErrorCode);

            string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts  == true) Alert(ErrAlert);

            string ErrLog   = StringConcatenate("Bid: ",MarketInfo(s_symbol,MODE_BID)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (cl.clnow > cl.manow && cl.clpre < cl.mapre)
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,clCloseSell); 
          if (sellClose  == false)
          {
            ErrorCode = GetLastError();
            ErrDesc   = ErrorDescription(ErrorCode);

            ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts == true) Alert(ErrAlert);

            ErrLog   = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{
   if (StringFind(s_symbol, "CADJPY") >= 0) return(9822221);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(9822222);
   
   if (StringFind(s_symbol, "XAUUSD") >= 0) return(9822231);
   if (StringFind(s_symbol, "XAGUSD") >= 0) return(982232);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(9822241);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(9822242);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(9822251);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(9822261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(9822262);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(9822263);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(9822264);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(9822265);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(9822266);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(9822267);
   if (StringFind(s_symbol, "EURDKK") >= 0) return(9822268);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(9822271);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(9822272);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(9822273);
   if (StringFind(s_symbol, "GBPNZD") >= 0) return(9822274);
   if (StringFind(s_symbol, "GBPCAD") >= 0) return(9822275);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(9822281);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(9822282);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(9822283);
   if (StringFind(s_symbol, "USDDKK") >= 0) return(9822284);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(9822291);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(9822292);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(9822293);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(9822294);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(9822295);
   
return(ManualMagic);
}




